Type to search.

Create a tool

Base URL
https://{kibana_url}
  • POST /api/agent_builder/tools
  • POST /s/{space_id}/api/agent_builder/tools
Auth The Elastic Stack includes Elastic's core products such as Elasticsearch, Kibana, Logstash, and Beats. Availability Generally available since 9.2 This functionality is generally available and ready for production usage. Unless stated otherwise on the page, this functionality is available when your Elastic Stack is deployed on Elastic Cloud Hosted, Elastic Cloud Enterprise, Elastic Cloud on Kubernetes, and self-managed environments. This documentation corresponds to the latest patch available for each minor version. If you're not using the latest patch, check the release notes for changes.

Create a new tool. Use this endpoint to define a custom tool with specific functionality and configuration for use by agents. To learn more about Agent Builder tools, refer to the tools documentation.

Required privileges

Privileges agentBuilder:manageTools

Path parameters

space_id string optional

An identifier for the space. If space_id is not provided in the URL, the default space is used. Refer to Spaces for more information.

Header parameters

kbn-xsrf string required

A required header to protect against CSRF attacks

Request body

configuration map string to object required

Tool-specific configuration parameters. See examples for details.

description string

Description of what the tool does.

id string required

Unique identifier for the tool.

tags string[] · default: []

Optional tags for categorizing and organizing tools.

type enum required

The type of tool to create (e.g., esql, index_search).

Values: esql index_search workflow mcp

Response

200

Indicates a successful response

application/json